//*****************************************************************************
// Project name:  RCI USB Midi Tester 18F4550
// HIDTransRcv (USB HID Read & Write Test)
// Use with UsbPICDemo.vdp
// 48 Mhz Clock Speed
// Setup for 20Mhz Crystal
// Written for EASYPIC5 using PORTB 4 Bit LCD
// PLLDIV (Div by 5), CPUDIV (Div by 2), USBDIV (Div by 2)
// Buffer Size for VB application should be set to 32
// PORTA Pulldown Low,  AtoD on RA2,  PORTD Pulldown Low
// PORTB used for 4 bit LCD Display
// PORTC used for Test Pushbuttonsm minus bits used for USB communications
// PORTD used to test PORT Write LED's
//
//*****************************************************************************
//*****Variable Declarations***************************************************
unsigned int ADCValue;
unsigned char userWR_buffer[64], userRD_buffer[64];
unsigned int df = 0 absolute 15;
unsigned char RcvByte[4];
unsigned char RcvByte1[4];
int midich;                          //0123456789012345
char *Message3  = "Trans ME to VBPC";
char *Message4  = "Test for message";
char *Message5  = "a third time....";
char *Message6  = "and a forth time";
char *text;
char *clkString;
//                          1234567890123456
char *Message1  = "Hey, Howah ya???";
char *Message2  = "P18F4550        ";
char *Message19 = "USB Data Tester ";
char *Message20 = "                ";

#define INPUT_REPORT_BYTES  32
#define OUTPUT_REPORT_BYTES  32
#define ReadPort PORTC
#define WritePort PORTD
#define PB1  ReadPort.F1
#define PB2  ReadPort.F2
#define usbInput      1
#define usbOutput1    2
#define usbOutput2    3         // Not used
#define usbReadADC    4
#define usbDoAll      5
#define Clock         6
#define Time          7
#define usbReadPort   13
#define usbWritePort  14
#define usbNothing    50
//****************************************************************************
void Delay1us()
{
Delay_us(1);
}
//****************************************************************************
void Delay1000ms()
{
Delay_ms(1000);
}
//****************************************************************************
void Delay50ms()
{
Delay_ms(50);
}
//*****************************************************************************
// Main Interrupt Routine
//*****************************************************************************
void interrupt()
{
  HID_InterruptProc();
}
//*****************************************************************************
// Initialization Routine
//*****************************************************************************
void Init_Main()
{
	INTCON = 0;             // Disable GIE, PEIE, TMR0IE,INT0IE,RBIE
	INTCON2 = 0xF5;
	INTCON3 = 0xC0;
	RCON.IPEN = 0;         // Disable Priority Levels on interrupts
	PIE1 = 0;
	PIE2 = 0;
	PIR1 = 0;
	PIR2 = 0;
	TRISA = 0b00001111;
	TRISB = 0b11111111;
	TRISC = 0b11111111;       //	Turn ON Midi Out
	TRISD = 0b00000000;
	TRISE = 0b00000111;
  Lcd_Config(&PORTB, 4, 5, 6, 3, 2, 1, 0); // Initialize LCD connected to PORTB
  LCD_Cmd(LCD_CLEAR);       // Clear display
  LCD_Cmd(LCD_CURSOR_OFF);  // Turn cursor off
}
//*****************************************************************************
//  Read ADC Routine for 18F4550
//*****************************************************************************
 unsigned int ReadADC(unsigned short channel)
{
 static unsigned int result absolute 0xFC3; // get the result in one swoop

 ADCON0 = channel << 2; // channel set, no go, no start
 ADCON2 = 0B10000111;   // left aligned, internal RC
 ADCON0.F0 = 1;         // AD module enabled
 delay_us(3);           // wait for conversion start
 ADCON0.F1 = 1;         // Conversion start
 while(ADCON0.F1){}     // wait to finish
 ADCON0.F0 = 0;         // disable module
 return result;
}
//*****************************************************************************
// Main Program Routine
//*****************************************************************************
void main()
{
  unsigned char i, j, k, l, n, ch, messcount, z, ADChan;
  ADChan = 2;
  midich = 0;
  ch = 0;
  df = 0;
  messcount = 0;
  n = usbNothing;
  Init_Main();
//************************************************
		Delay1000ms();
		Delay1000ms();
		LCD_Out(1, 1, Message1);		    //  Displays Message on Row 1
		LCD_Out(2, 1, Message2);		    //  Displays Message on Row 2
		Delay1000ms();
//************************************************
//************************************************
  Lcd_Out(1, 1, "HID TransRcv!   ");
  Delay1000ms();
  HID_Enable(&userRD_buffer, &userWR_buffer);
	LCD_Out(1, 1, "HID Enabled     ");
  Delay1000ms();
//************************************************
  while (1 == 1)
  {

//********Read USB Buffer to Fetch Commands from Visual Basic ****************
      k = HID_Read();
      i = 0;
      while (i < k)
      {
          ch = userRD_buffer[0];  // used by HID routine
          i++;
          if (ch == 1)            // If VB Command = 1....
          n = usbInput;
          if (ch == 2)            // If VB Command = 2....
          n = usbOutput1;
          if (ch == 3)            // If VB Command = 3....
          n = usbOutput2;
          if (ch == 4)            // If VB Command = 4....
          n = usbReadADC;
          if (ch == 5)            // If VB Command = 5....
          n = usbDoAll;
          if (ch == 6)            // If VB Command = 6....
          n = Clock;
          if (ch == 13)           // If VB Command = 13....
          n = usbReadPort;
          if (ch == 14)           // If VB Command = 14....
          n = usbWritePort;
          if (ch == 50)
          n = usbNothing;
      }
//****************************************************************************
//****************************************************************************
switch(n)
		{
//****************************************************************************
// Receive Text Message from VB ****************
		case usbInput:   // 1
		              //0123456789012345
		  LCD_Out(1, 1,"Rcv Text From VB");
      LCD_Out(2, 1,"                ");
      i = 0;
      while (i < k)
      {
          ch = userRD_buffer[i];
          i++;
          if (ch < 32)
             ch = 32;
          LCD_Cmd(LCD_SECOND_ROW + (i - 2));
          LCD_Chr_Cp(ch);
      }
      Delay1000ms();
      ch = 0;
      n = usbNothing;

		break;
//****************************************************************************
//Send Text Message to VB *****************************
		case usbOutput1:   // 2
          LCD_Out(1, 1,"Send text to VB ");
          LCD_Out(2, 1,"                ");
          messcount++;
          if (messcount == 1)
              text = Message3;
          if (messcount == 2)
              text = Message4;
          if (messcount == 3)
              text = Message5;
          if (messcount == 4)
              text = Message6;
          if (messcount >= 4)
             messcount = 0;
         j = 0;
         userWR_buffer[0] = 2;   // Write Buffer (0) is Command Byte for VB
    while(text[j])
      {
      userWR_buffer[j + 1]= text[j];
      j++;
      LCD_Cmd(LCD_SECOND_ROW + (j - 1));
      LCD_Chr_Cp(text[j-1]);
      }
      while (!HID_Write(&userWR_buffer, OUTPUT_REPORT_BYTES));
      n = usbNothing;
      Delay1000ms();
      ch = 0;
      n = usbNothing;

		break;
//*****************************************************************************
// Not Used **********************************
		case usbOutput2:   // 3

		break;
//*****************************************************************************
//  Send ADC to VB ****************************
    case usbReadADC:   // 4

          ADCValue = ReadADC(ADChan) >> 2;
// *******convert ADC value to BCD****************
          ch = (ADCValue / 100) % 10;
          ch = (ADCValue / 10) % 10;
          ch = ADCValue % 10;
//************************************************
          userWR_buffer[0] = 4;   // Write Buffer (0) is Command Byte for VB
          userWR_buffer[18] = ADCValue;   //Send 1 less than Buffer(#)
          userWR_buffer[21] =  ADChan;
          if (userRD_buffer[22] == 1) // Bypasses Display Section to save time
             {
             goto jump1;
             }
          LCD_Out(1, 1, "Send ADC        ");
          LCD_Out(2, 1,"                 ");
          LCD_Cmd(LCD_SECOND_ROW);
          BytetoStr(ADCValue, RcvByte1);
          LCD_Out(2, 1, RcvByte1);	  //  Call Sub to Convert to BCD
          Delay1000ms();
jump1:
      while (!HID_Write(&userWR_buffer, OUTPUT_REPORT_BYTES));
          Delay_us(1);
          ch = 0;
          n = usbNothing;

		break;
//*****************************************************************************
		case usbDoAll:   // 5
          LCD_Out(1, 1,"Do All Functions");
          LCD_Out(2, 1,"                ");
          userWR_buffer[0] = 5;    // Write Buffer (0) is Command Byte for VB
          
      while (!HID_Write(&userWR_buffer, OUTPUT_REPORT_BYTES));
            
          Delay1000ms();
          ch = 0;
          n = usbNothing;

		break;
//****************************************************************************
//  Send ReadPort to VB ****************************
		case usbReadPort:   // 13
          userWR_buffer[0] = 13;   // Write Buffer (0) is Command Byte for VB
          userWR_buffer[19] = ReadPort;
          if (userRD_buffer[22] == 1)  // Bypasses Display Section to save time
             {
             goto jump;
             }
          LCD_Out(1, 1,"Read Port       ");
          LCD_Out(2, 1,"                ");
          LCD_Cmd(LCD_SECOND_ROW);
          BytetoStr(ReadPort, RcvByte1);
          LCD_Out(2, 1, RcvByte1);	  // Call Sub to Convert to BCD
          Delay1000ms();
jump:
      while (!HID_Write(&userWR_buffer, OUTPUT_REPORT_BYTES));

          Delay_us(1);
          ch = 0;
          n = usbNothing;
          
		break;
//****************************************************************************
//  Receieve VB Command to Write PORTD ****************************
		case usbWritePort:   // 14
          LCD_Out(1, 1,"Write Port      ");
          LCD_Out(2, 1,"                ");
          userWR_buffer[0] = 14;    // Write Buffer (0) is Command Byte for VB
          PORTD = userRD_buffer[20];
          Delay50ms();
          LCD_Cmd(LCD_SECOND_ROW);
          BytetoStr(PORTD, RcvByte);
          LCD_Out(2, 1, RcvByte);	  //  Call Sub to Convert to BCD
          Delay1000ms();
          n = usbNothing;
          ch = 0;
          
		break;
//****************************************************************************
// Receive Text Message from VB ****************
		case Clock:   // 1
      i = 0;
      while (i < 11)
          {
          ch = userRD_buffer[i];
          i++;
          if (ch < 32)
             ch = 32;
          LCD_Cmd(LCD_FIRST_ROW + (i - 2));	//  Move Cursor to the First Row
          LCD_Chr_Cp(ch);	                  //  Write Characters
          }
          LCD_Out_Cp("      ");
          i = 11;
      while (i < k)
          {
          ch = userRD_buffer[i];
          i++;
          if (ch < 32)
              ch = 32;
          LCD_Cmd(LCD_SECOND_ROW + (i - 11));	//  Move Cursor to the Second Row
          LCD_Chr_Cp(ch);	                    //  Write Characters
          }
          LCD_Out_Cp("   ");
          if (userRD_buffer[22] == 0)
             {
             Delay1000ms();
             }
          ch = 0;
      
		break;
//****************************************************************************
home:
 		case usbNothing:   // 50
          // Loop through here and wait for something to happen...
          LCD_Out(1, 1,"USB Data Tester ");
          LCD_Out(2, 1,"                ");
          Delay50ms();
          ch = 0;
          
		break;
//****************************************************************************
loop:
   		default:
       z = 0;
        } // End Switch
  } // End While
  HID_Disable();
}// End Main
//****************************************************************************
//****************************************************************************